"The [Resource Manager](https://control.ros.org/master/doc/getting_started/getting_started.html#resource-manager) (RM) abstracts physical hardware and its drivers (called _hardware components_) for the ros2_control framework. The RM loads the components using the `pluginlib`-library, manages their lifecycle and components’ state and command interfaces. The abstraction provided by RM allows reuse of implemented hardware components, e.g., robot and gripper, without any implementation, and flexible hardware application for state and command interfaces, e.g., separate hardware/communication libraries for motor control and encoder reading.

In the control loop execution, the RM’s `read()` and `write()` methods handle the communication with the hardware components."
https://control.ros.org/master/doc/getting_started/getting_started.html